//  iframe 通信中心
class MessageCenter { 
    constructor() { 
        //  缓存事件队列
        this.messageCallbackMap = new Map();
        this.init()
    }

    send({ actionType, data }) {
        window.parent.postMessage({
            actionType,
            data
        }, '*');
    }

    listen(actionType, callback) {
        let activeQuene = this.messageCallbackMap.get(actionType);
        if (activeQuene?.length > 0) {
            activeQuene.push(callback)
        } else { 
            this.messageCallbackMap.set(actionType, [callback])
        }
    }

    init() { 
        window.addEventListener('message', (e) => { 
            const { actionType, data } = e.data;
            const quene = this.messageCallbackMap.get(actionType) ||  [];
            let index = 0;
            while (index < quene.length) { 
                const callback = quene[index];
                callback(data)
                index++
            }
        })
    }
}

// messageCenter在每个iframe内实例化一次
const messageCenter = new MessageCenter();

export default messageCenter;